require 'soar_idm/soar_idm'

module Soar
  module Registry
    module Identity
      module Provider
        module Stub

          ##
          # Work in progress. Do not use.
          ## 
          class Uuid < SoarIdm::IdmApi

            ##
            # @param [Array<Hash{String => Hash, String, Number}>] identities
            # @param [Soar::Registry::Directory] directory
            # @raise [ArgumentError]
            ##
            def initialize(directory:)
              @directory = directory
            end

            ##
            # @param [String] identity_uuid
            # @return [Array<String>] list of roles
            ##
            def calculate_roles(identity_uuid)
              begin
                identity = @directory.fetch(identity_uuid)
                return identity.key?('roles') ? identity['roles'].keys : []
              rescue Soar::Registry::Directory::Error::NoEntriesFoundError => e
                return []
              end
            end

            ##
            # @param [String] identity_uuid
            # @return [Array<String,Number>] list of identifiers
            ##
            def calculate_identifiers(identity_uuid)
            end

            ## 
            # @param [String] identity_uuid
            # @param [String] role
            # @return [Hash{String => String, Number, Hash, Array}] A hash of attributes 
            ##
            def calculate_attributes(identity_uuid, role)
              identity = @directory.fetch(identity_uuid)
              return {
                role => identity['roles'].key?(role) ? identity['roles'][role] : {}
              } 
            end 

            ##
            # @param [String] identity_uuid
            # @return [Hash{String => String, Number, Hash, Array}] A hash of attributes 
            def calculate_all_attributes(identity_uuid)
              begin
                identity = @directory.fetch(identity_uuid)
                return identity
              rescue Soar::Registry::Directory::Error::NoEntriesFoundError => e
                raise SoarIdm::IdentityError, e.message
              end
            end

            ##
            # @param [String] identity_uuid
            # @return [Array<String>] identities
            ##
            def calculate_identities(identity_uuid)
              return [identity_uuid]
            end


          end
        end
      end
    end
  end
end
